﻿using System;
using System.Collections;
using Alachisoft.NCache.Runtime.Caching;
using Alachisoft.NCache.Web.Caching;

// ===============================================================================
// Alachisoft (R) NCache Sample Code.
// NCache NamedTags sample class
// ===============================================================================
// Copyright © Alachisoft.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
// ===============================================================================


namespace GroupsAndTags
{
	public class NamedTags
	{
		public static void RunNamedTagsDemo()
		{
			try
			{
				Cache cache;
				cache = NCache.InitializeCache("mypartitionedcache");
				cache.Clear();

                //Creating named tag dictionary. 
				NamedTagsDictionary namedTagDict = new NamedTagsDictionary();


				namedTagDict.Add("Department", "Marketing");
				namedTagDict.Add("EmployeeCount", 40);

				cache.Add("EmployeeID:1", "John Samuel", namedTagDict);
				cache.Add("EmployeeID:2", "David Parker", namedTagDict);


				string query = "SELECT $Text$ WHERE this.Department = ? AND this.EmployeeCount > ?";

				Hashtable values = new Hashtable();
				values["Department"] = "Marketing";
				values["EmployeeCount"] = 35;

				IDictionary resultItems = cache.SearchEntries(query, values);

				if (resultItems.Count > 0)
				{
					IEnumerator iter = resultItems.Values.GetEnumerator();
					while (iter.MoveNext())
					{
						Console.WriteLine(iter.Current.ToString());
					}
				}

				//Must dispose cache
				cache.Dispose();

			}
			catch (Exception ex)
			{
				Console.WriteLine(ex.Message);
			}
		}
	}

}